/*
 *  simpleread.cc the shortest program skeleton to exercise qnetevent
 *  this expands on that and fills a root TTree
 *  allowing someone to explore the data with the root package.
 *  Go into the loop and add any sort of manipulation you want.
 */

#include "qneteventlist.h"
#include <iostream>
#include "TFile.h"
#include "TTree.h"
using namespace std;

int main(int argc, char *argv[]){

  int histogram[100];
  for(int i=0; i<100; i++)histogram[i] = 0;

  qneteventlist mylist(argc,argv);
  
  int foundCE = 0;

  unsigned int mytime = 0;
  int rise1 = -1; int rise2 = -1; int rise3=-1; int rise4=-1;
  int fall1 = -1; int fall2 = -1; int fall3=-1; int fall4=-1;
  int nrise1= -1; int nrise2 = -1; int nrise3 = -1; int nrise4=-1;
  int nfall1= -1; int nfall2 = -1; int nfall3 = -1; int nfall4=-1;
  int lastrise1=-1; int lastrise2=-1; int lastrise3=-1; int lastrise4=-1;
  int lastfall1=-1; int lastfall2=-1; int lastfall3=-1; int lastfall4=-1;
  int nstrings = 0;

  TFile treefile("output.root","RECREATE","Root file with walta tree");
  TTree *t_tree = new TTree("walta","walta");
  TBranch *b_time = t_tree->Branch("time", &mytime, "time/i");
  TBranch *b_rise1 = t_tree->Branch("rise1", &rise1, "rise1/I");
  TBranch *b_rise2 = t_tree->Branch("rise2", &rise2, "rise2/I");
  TBranch *b_rise3 = t_tree->Branch("rise3", &rise3, "rise3/I");
  TBranch *b_rise4 = t_tree->Branch("rise4", &rise4, "rise4/I");
  TBranch *b_fall1 = t_tree->Branch("fall1", &fall1, "fall1/I");
  TBranch *b_fall2 = t_tree->Branch("fall2", &fall2, "fall2/I");
  TBranch *b_fall3 = t_tree->Branch("fall3", &fall3, "fall3/I");
  TBranch *b_fall4 = t_tree->Branch("fall4", &fall4, "fall4/I");
  TBranch *b_nrise1 = t_tree->Branch("nrise1", &nrise1, "nrise1/I");
  TBranch *b_nrise2 = t_tree->Branch("nrise2", &nrise2, "nrise2/I");
  TBranch *b_nrise3 = t_tree->Branch("nrise3", &nrise3, "nrise3/I");
  TBranch *b_nrise4 = t_tree->Branch("nrise4", &nrise4, "nrise4/I");
  TBranch *b_nfall1 = t_tree->Branch("nfall1", &nfall1, "nfall1/I");
  TBranch *b_nfall2 = t_tree->Branch("nfall2", &nfall2, "nfall2/I");
  TBranch *b_nfall3 = t_tree->Branch("nfall3", &nfall3, "nfall3/I");
  TBranch *b_nfall4 = t_tree->Branch("nfall4", &nfall4, "nfall4/I");
  TBranch *b_lastrise1 = t_tree->Branch("lastrise1", &lastrise1, "lastrise1/I");
  TBranch *b_lastrise2 = t_tree->Branch("lastrise2", &lastrise2, "lastrise2/I");
  TBranch *b_lastrise3 = t_tree->Branch("lastrise3", &lastrise3, "lastrise3/I");
  TBranch *b_lastrise4 = t_tree->Branch("lastrise4", &lastrise4, "lastrise4/I");
  TBranch *b_lastfall1 = t_tree->Branch("lastfall1", &lastfall1, "lastfall1/I");
  TBranch *b_lastfall2 = t_tree->Branch("lastfall2", &lastfall2, "lastfall2/I");
  TBranch *b_lastfall3 = t_tree->Branch("lastfall3", &lastfall3, "lastfall3/I");
  TBranch *b_lastfall4 = t_tree->Branch("lastfall4", &lastfall4, "lastfall4/I");
  TBranch *b_nstrings = t_tree->Branch("nstrings", &nstrings, "nstrings/I");

  while(!mylist.End()){
    int bad = mylist.GetNextEvent();
    if(!bad && foundCE >= 1){  
      mytime = mylist.CurrentEvent.triggercount;
      rise1 = mylist.CurrentEvent.rise[0];
      rise2 = mylist.CurrentEvent.rise[1];
      rise3 = mylist.CurrentEvent.rise[2];
      rise4 = mylist.CurrentEvent.rise[3];
      nrise1 = mylist.CurrentEvent.numrise[0];
      nrise2 = mylist.CurrentEvent.numrise[1];
      nrise3 = mylist.CurrentEvent.numrise[2];
      nrise4 = mylist.CurrentEvent.numrise[3];
      lastrise1 = mylist.CurrentEvent.lastrise[0];
      lastrise2 = mylist.CurrentEvent.lastrise[1];
      lastrise3 = mylist.CurrentEvent.lastrise[2];
      lastrise4 = mylist.CurrentEvent.lastrise[3];
      fall1 = mylist.CurrentEvent.fall[0];
      fall2 = mylist.CurrentEvent.fall[1];
      fall3 = mylist.CurrentEvent.fall[2];
      fall4 = mylist.CurrentEvent.fall[3];
      nfall1 = mylist.CurrentEvent.numfall[0];
      nfall2 = mylist.CurrentEvent.numfall[1];
      nfall3 = mylist.CurrentEvent.numfall[2];
      nfall4 = mylist.CurrentEvent.numfall[3];
      lastfall1 = mylist.CurrentEvent.lastfall[0];
      lastfall2 = mylist.CurrentEvent.lastfall[1];
      lastfall3 = mylist.CurrentEvent.lastfall[2];
      lastfall4 = mylist.CurrentEvent.lastfall[3];
      nstrings = mylist.CurrentEvent.nstrings;
      // always test for bad = 0, then do something with this event.
      // cout << mylist.CurrentEvent << endl;
      if(mylist.CurrentEvent.rise[3] >= 0 && mylist.CurrentEvent.rise[1] >= 0){
        int diff = mylist.CurrentEvent.rise[3] - mylist.CurrentEvent.rise[1];
        //cout << "diff " << diff << endl;
        float denominator = 250/0.75;
	    if(diff > 0 && diff < 100*denominator)histogram[(int)(diff/denominator)]++;

	   
      }
      t_tree->Fill();
    }
      foundCE += mylist.FoundCE;
  }

  t_tree->Write("", TObject::kOverwrite);

  //for(int i=0; i<100; i++)cout << i << " " << histogram[i] << endl;
  return 0;
}
