//////////////////////////////////////////////////////////
// This class has been automatically generated on
// Tue Jun 14 13:54:20 2011 by ROOT version 5.28/00d
// from TTree walta/walta
// found on file: output.root
//////////////////////////////////////////////////////////

#ifndef walta_h
#define walta_h

#include <TROOT.h>
#include <TChain.h>
#include <TFile.h>

class walta {
public :
   TTree          *fChain;   //!pointer to the analyzed TTree or TChain
   Int_t           fCurrent; //!current Tree number in a TChain

   // Declaration of leaf types
   UInt_t           time;
   Int_t           rise1;
   Int_t           rise2;
   Int_t           rise3;
   Int_t           rise4;
   Int_t           fall1;
   Int_t           fall2;
   Int_t           fall3;
   Int_t           fall4;
   Int_t           nrise1;
   Int_t           nrise2;
   Int_t           nrise3;
   Int_t           nrise4;
   Int_t           nfall1;
   Int_t           nfall2;
   Int_t           nfall3;
   Int_t           nfall4;
   Int_t           lastrise1;
   Int_t           lastrise2;
   Int_t           lastrise3;
   Int_t           lastrise4;
   Int_t           lastfall1;
   Int_t           lastfall2;
   Int_t           lastfall3;
   Int_t           lastfall4;
   Int_t           nstrings;

   // List of branches
   TBranch        *b_time;   //!
   TBranch        *b_rise1;   //!
   TBranch        *b_rise2;   //!
   TBranch        *b_rise3;   //!
   TBranch        *b_rise4;   //!
   TBranch        *b_fall1;   //!
   TBranch        *b_fall2;   //!
   TBranch        *b_fall3;   //!
   TBranch        *b_fall4;   //!
   TBranch        *b_nrise1;   //!
   TBranch        *b_nrise2;   //!
   TBranch        *b_nrise3;   //!
   TBranch        *b_nrise4;   //!
   TBranch        *b_nfall1;   //!
   TBranch        *b_nfall2;   //!
   TBranch        *b_nfall3;   //!
   TBranch        *b_nfall4;   //!
   TBranch        *b_lastrise1;   //!
   TBranch        *b_lastrise2;   //!
   TBranch        *b_lastrise3;   //!
   TBranch        *b_lastrise4;   //!
   TBranch        *b_lastfall1;   //!
   TBranch        *b_lastfall2;   //!
   TBranch        *b_lastfall3;   //!
   TBranch        *b_lastfall4;   //!
   TBranch        *b_nstrings;   //!

   walta(TTree *tree=0);
   virtual ~walta();
   virtual Int_t    Cut(Long64_t entry);
   virtual Int_t    GetEntry(Long64_t entry);
   virtual Long64_t LoadTree(Long64_t entry);
   virtual void     Init(TTree *tree);
   virtual void     Loop();
   virtual Bool_t   Notify();
   virtual void     Show(Long64_t entry = -1);
};

#endif

#ifdef walta_cxx
walta::walta(TTree *tree)
{
// if parameter tree is not specified (or zero), connect the file
// used to generate this class and read the Tree.
   if (tree == 0) {
      TFile *f = (TFile*)gROOT->GetListOfFiles()->FindObject("output.root");
      if (!f) {
         f = new TFile("output.root");
      }
      tree = (TTree*)gDirectory->Get("walta");

   }
   Init(tree);
}

walta::~walta()
{
   if (!fChain) return;
   delete fChain->GetCurrentFile();
}

Int_t walta::GetEntry(Long64_t entry)
{
// Read contents of entry.
   if (!fChain) return 0;
   return fChain->GetEntry(entry);
}
Long64_t walta::LoadTree(Long64_t entry)
{
// Set the environment to read one entry
   if (!fChain) return -5;
   Long64_t centry = fChain->LoadTree(entry);
   if (centry < 0) return centry;
   if (!fChain->InheritsFrom(TChain::Class()))  return centry;
   TChain *chain = (TChain*)fChain;
   if (chain->GetTreeNumber() != fCurrent) {
      fCurrent = chain->GetTreeNumber();
      Notify();
   }
   return centry;
}

void walta::Init(TTree *tree)
{
   // The Init() function is called when the selector needs to initialize
   // a new tree or chain. Typically here the branch addresses and branch
   // pointers of the tree will be set.
   // It is normally not necessary to make changes to the generated
   // code, but the routine can be extended by the user if needed.
   // Init() will be called many times when running on PROOF
   // (once per file to be processed).

   // Set branch addresses and branch pointers
   if (!tree) return;
   fChain = tree;
   fCurrent = -1;
   fChain->SetMakeClass(1);

   fChain->SetBranchAddress("time", &time, &b_time);
   fChain->SetBranchAddress("rise1", &rise1, &b_rise1);
   fChain->SetBranchAddress("rise2", &rise2, &b_rise2);
   fChain->SetBranchAddress("rise3", &rise3, &b_rise3);
   fChain->SetBranchAddress("rise4", &rise4, &b_rise4);
   fChain->SetBranchAddress("fall1", &fall1, &b_fall1);
   fChain->SetBranchAddress("fall2", &fall2, &b_fall2);
   fChain->SetBranchAddress("fall3", &fall3, &b_fall3);
   fChain->SetBranchAddress("fall4", &fall4, &b_fall4);
   fChain->SetBranchAddress("nrise1", &nrise1, &b_nrise1);
   fChain->SetBranchAddress("nrise2", &nrise2, &b_nrise2);
   fChain->SetBranchAddress("nrise3", &nrise3, &b_nrise3);
   fChain->SetBranchAddress("nrise4", &nrise4, &b_nrise4);
   fChain->SetBranchAddress("nfall1", &nfall1, &b_nfall1);
   fChain->SetBranchAddress("nfall2", &nfall2, &b_nfall2);
   fChain->SetBranchAddress("nfall3", &nfall3, &b_nfall3);
   fChain->SetBranchAddress("nfall4", &nfall4, &b_nfall4);
   fChain->SetBranchAddress("lastrise1", &lastrise1, &b_lastrise1);
   fChain->SetBranchAddress("lastrise2", &lastrise2, &b_lastrise2);
   fChain->SetBranchAddress("lastrise3", &lastrise3, &b_lastrise3);
   fChain->SetBranchAddress("lastrise4", &lastrise4, &b_lastrise4);
   fChain->SetBranchAddress("lastfall1", &lastfall1, &b_lastfall1);
   fChain->SetBranchAddress("lastfall2", &lastfall2, &b_lastfall2);
   fChain->SetBranchAddress("lastfall3", &lastfall3, &b_lastfall3);
   fChain->SetBranchAddress("lastfall4", &lastfall4, &b_lastfall4);
   fChain->SetBranchAddress("nstrings", &nstrings, &b_nstrings);
   Notify();
}

Bool_t walta::Notify()
{
   // The Notify() function is called when a new file is opened. This
   // can be either for a new TTree in a TChain or when when a new TTree
   // is started when using PROOF. It is normally not necessary to make changes
   // to the generated code, but the routine can be extended by the
   // user if needed. The return value is currently not used.

   return kTRUE;
}

void walta::Show(Long64_t entry)
{
// Print contents of entry.
// If entry is not specified, print current entry
   if (!fChain) return;
   fChain->Show(entry);
}
Int_t walta::Cut(Long64_t entry)
{
// This function may be called from Loop.
// returns  1 if entry is accepted.
// returns -1 otherwise.
   return 1;
}
#endif // #ifdef walta_cxx
